## Add items to a known list

### cURL

```bash
curl --request PATCH \
  --url https://prod01-apigw.yourcompany.fabric.zone/api-list/list/{listId}/items \
  --header 'Content-Type: application/json' \
  --header 'x-site-context: <x-site-context>' \
  --data '[\
  {\
    "itemId": "1234"\
  },\
  {\
    "sku": "SKU_1"\
  }\
]'
```

### Python

```python
import requests

url = "https://prod01-apigw.yourcompany.fabric.zone/api-list/list/{listId}/items"

payload = [{ "itemId": "1234" }, { "sku": "SKU_1" }]
headers = {
    "x-site-context": "<x-site-context>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript (Fetch)

```javascript
const options = {
  method: 'PATCH',
  headers: {'x-site-context': '<x-site-context>', 'Content-Type': 'application/json'},
  body: JSON.stringify([{itemId: '1234'}, {sku: 'SKU_1'}])
};

fetch('https://prod01-apigw.yourcompany.fabric.zone/api-list/list/{listId}/items', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```php
$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://prod01-apigw.yourcompany.fabric.zone/api-list/list/{listId}/items",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PATCH",
  CURLOPT_POSTFIELDS => json_encode([
    [
        'itemId' => '1234'
    ],
    [
        'sku' => 'SKU_1'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Content-Type: application/json",
    "x-site-context: <x-site-context>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
```

### Go

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

url := "https://prod01-apigw.yourcompany.fabric.zone/api-list/list/{listId}/items"

payload := strings.NewReader("[\n  {\n    \"itemId\": \"1234\"\n  },\n  {\n    \"sku\": \"SKU_1\"\n  }\n]")

req, _ := http.NewRequest("PATCH", url, payload)

req.Header.Add("x-site-context", "<x-site-context>")
	req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}
```

### Unirest (Java)

```java
HttpResponse<String> response = Unirest.patch("https://prod01-apigw.yourcompany.fabric.zone/api-list/list/{listId}/items")
  .header("x-site-context", "<x-site-context>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"itemId\": \"1234\"\n  },\n  {\n    \"sku\": \"SKU_1\"\n  }\n]")
  .asString();
```

### Ruby

```ruby
require 'uri'
require 'net/http'

url = URI("https://prod01-apigw.yourcompany.fabric.zone/api-list/list/{listId}/items")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["x-site-context"] = '<x-site-context>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"itemId\": \"1234\"\n  },\n  {\n    \"sku\": \"SKU_1\"\n  }\n]"

response = http.request(request)
puts response.read_body
```

### Response Status Codes

- **200**: Items successfully added/deleted to list
- **400**: Bad Request

### JSON Response Example
```json
{
  "message": "Items successfully added/deleted to list",
  "items": [
    {
      "_id": "5fee9d59f2f08a1b3cbdea08",
      "createdAt": "2020-12-31T02:09:53.914Z",
      "updatedAt": "2020-12-31T02:09:53.914Z",
      "listId": "6155e5f6e311670009aeb478",
      "itemId": "1234",
      "sku": "SKU_1"
    }
  ]
}
```

### Headers

- **x-site-context**: string, required
    - The `x-site-context` header is a JSON object that contains information about the source you wish to pull from. The mandatory `account` is the 24 character identifier found in Copilot. The `channel` (Sales channel ID), `stage` (environment name), and `date` attributes can be used to further narrow the scope of your data source.
    - Example: `"{\"date\": \"2023-01-01T00:00:00.000Z\", \"channel\": 12, \"account\": \"1234abcd5678efgh9ijklmno\",\"stage\":\"production\"}"`

### Path Parameters

- **listId**: string, required

### Body

- Minimum array length: `1`
    - **Option 1**
    - **Option 2**
        
    - **sku**: string, required.
        - Example: `"SKU_1"`
    - **itemId**: string.
        - Example: `"1234"`

### Response Structure
- **Message**: string
    - Example: `"Items successfully added/deleted to list"`
- **Items**: object[]
